<?php
/**
 * User
 *
 * PHP version 5
 *
 * @category Class
 * @package  OSDN
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * OSDN REST API v0 beta
 *
 * OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.jp/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.jp/projects/osdn-codes/releases/p14859 .
 *
 * OpenAPI spec version: 0.0.20160304
 * Contact: admin@osdn.jp
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace OSDN\Model;

use \ArrayAccess;

/**
 * User Class Doc Comment
 *
 * @category    Class */
/** 
 * @package     OSDN
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class User implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'User';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = array(
        'id' => 'int',
        'name' => 'string',
        'display_name' => 'string',
        'unix_status' => 'bool',
        'unix_uid' => 'int',
        'authorized_keys' => 'string',
        'timezone' => 'string',
        'last_update' => '\DateTime',
        'add_date' => '\DateTime',
        'language' => 'string',
        'groups' => '\OSDN\Model\SimpleGroup[]',
        'chambers' => '\OSDN\Model\SimpleChamber[]',
        'skills' => '\OSDN\Model\Skill[]'
    );

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = array(
        'id' => 'id',
        'name' => 'name',
        'display_name' => 'display_name',
        'unix_status' => 'unix_status',
        'unix_uid' => 'unix_uid',
        'authorized_keys' => 'authorized_keys',
        'timezone' => 'timezone',
        'last_update' => 'last_update',
        'add_date' => 'add_date',
        'language' => 'language',
        'groups' => 'groups',
        'chambers' => 'chambers',
        'skills' => 'skills'
    );

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = array(
        'id' => 'setId',
        'name' => 'setName',
        'display_name' => 'setDisplayName',
        'unix_status' => 'setUnixStatus',
        'unix_uid' => 'setUnixUid',
        'authorized_keys' => 'setAuthorizedKeys',
        'timezone' => 'setTimezone',
        'last_update' => 'setLastUpdate',
        'add_date' => 'setAddDate',
        'language' => 'setLanguage',
        'groups' => 'setGroups',
        'chambers' => 'setChambers',
        'skills' => 'setSkills'
    );

    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = array(
        'id' => 'getId',
        'name' => 'getName',
        'display_name' => 'getDisplayName',
        'unix_status' => 'getUnixStatus',
        'unix_uid' => 'getUnixUid',
        'authorized_keys' => 'getAuthorizedKeys',
        'timezone' => 'getTimezone',
        'last_update' => 'getLastUpdate',
        'add_date' => 'getAddDate',
        'language' => 'getLanguage',
        'groups' => 'getGroups',
        'chambers' => 'getChambers',
        'skills' => 'getSkills'
    );

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = array();

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['display_name'] = isset($data['display_name']) ? $data['display_name'] : null;
        $this->container['unix_status'] = isset($data['unix_status']) ? $data['unix_status'] : null;
        $this->container['unix_uid'] = isset($data['unix_uid']) ? $data['unix_uid'] : null;
        $this->container['authorized_keys'] = isset($data['authorized_keys']) ? $data['authorized_keys'] : null;
        $this->container['timezone'] = isset($data['timezone']) ? $data['timezone'] : null;
        $this->container['last_update'] = isset($data['last_update']) ? $data['last_update'] : null;
        $this->container['add_date'] = isset($data['add_date']) ? $data['add_date'] : null;
        $this->container['language'] = isset($data['language']) ? $data['language'] : null;
        $this->container['groups'] = isset($data['groups']) ? $data['groups'] : null;
        $this->container['chambers'] = isset($data['chambers']) ? $data['chambers'] : null;
        $this->container['skills'] = isset($data['skills']) ? $data['skills'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = array();
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets id
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     * @param int $id
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets display_name
     * @return string
     */
    public function getDisplayName()
    {
        return $this->container['display_name'];
    }

    /**
     * Sets display_name
     * @param string $display_name
     * @return $this
     */
    public function setDisplayName($display_name)
    {
        $this->container['display_name'] = $display_name;

        return $this;
    }

    /**
     * Gets unix_status
     * @return bool
     */
    public function getUnixStatus()
    {
        return $this->container['unix_status'];
    }

    /**
     * Sets unix_status
     * @param bool $unix_status
     * @return $this
     */
    public function setUnixStatus($unix_status)
    {
        $this->container['unix_status'] = $unix_status;

        return $this;
    }

    /**
     * Gets unix_uid
     * @return int
     */
    public function getUnixUid()
    {
        return $this->container['unix_uid'];
    }

    /**
     * Sets unix_uid
     * @param int $unix_uid
     * @return $this
     */
    public function setUnixUid($unix_uid)
    {
        $this->container['unix_uid'] = $unix_uid;

        return $this;
    }

    /**
     * Gets authorized_keys
     * @return string
     */
    public function getAuthorizedKeys()
    {
        return $this->container['authorized_keys'];
    }

    /**
     * Sets authorized_keys
     * @param string $authorized_keys
     * @return $this
     */
    public function setAuthorizedKeys($authorized_keys)
    {
        $this->container['authorized_keys'] = $authorized_keys;

        return $this;
    }

    /**
     * Gets timezone
     * @return string
     */
    public function getTimezone()
    {
        return $this->container['timezone'];
    }

    /**
     * Sets timezone
     * @param string $timezone
     * @return $this
     */
    public function setTimezone($timezone)
    {
        $this->container['timezone'] = $timezone;

        return $this;
    }

    /**
     * Gets last_update
     * @return \DateTime
     */
    public function getLastUpdate()
    {
        return $this->container['last_update'];
    }

    /**
     * Sets last_update
     * @param \DateTime $last_update
     * @return $this
     */
    public function setLastUpdate($last_update)
    {
        $this->container['last_update'] = $last_update;

        return $this;
    }

    /**
     * Gets add_date
     * @return \DateTime
     */
    public function getAddDate()
    {
        return $this->container['add_date'];
    }

    /**
     * Sets add_date
     * @param \DateTime $add_date
     * @return $this
     */
    public function setAddDate($add_date)
    {
        $this->container['add_date'] = $add_date;

        return $this;
    }

    /**
     * Gets language
     * @return string
     */
    public function getLanguage()
    {
        return $this->container['language'];
    }

    /**
     * Sets language
     * @param string $language
     * @return $this
     */
    public function setLanguage($language)
    {
        $this->container['language'] = $language;

        return $this;
    }

    /**
     * Gets groups
     * @return \OSDN\Model\SimpleGroup[]
     */
    public function getGroups()
    {
        return $this->container['groups'];
    }

    /**
     * Sets groups
     * @param \OSDN\Model\SimpleGroup[] $groups
     * @return $this
     */
    public function setGroups($groups)
    {
        $this->container['groups'] = $groups;

        return $this;
    }

    /**
     * Gets chambers
     * @return \OSDN\Model\SimpleChamber[]
     */
    public function getChambers()
    {
        return $this->container['chambers'];
    }

    /**
     * Sets chambers
     * @param \OSDN\Model\SimpleChamber[] $chambers
     * @return $this
     */
    public function setChambers($chambers)
    {
        $this->container['chambers'] = $chambers;

        return $this;
    }

    /**
     * Gets skills
     * @return \OSDN\Model\Skill[]
     */
    public function getSkills()
    {
        return $this->container['skills'];
    }

    /**
     * Sets skills
     * @param \OSDN\Model\Skill[] $skills
     * @return $this
     */
    public function setSkills($skills)
    {
        $this->container['skills'] = $skills;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this));
    }
}


